#include "Csocket.h"
#include <signal.h>

#define PORT	1234
#define PEM	"/home/psychon/.znc/znc.pem"
#define HOST	"192.168.2.102"

static char buf[1024 * 1024];

class CMySock : public Csock {
public:
	CMySock() : Csock() {
	}

	CMySock (const CS_STRING & sHostname, u_short iport, int itimeout = 60)
		: Csock(sHostname, iport, itimeout) {
	}

	Csock *GetSockObj(const CS_STRING & sHostname, u_short iPort) {
		Csock *p = new CMySock(sHostname, iPort);
		p->Write(buf, sizeof(buf));
		CS_DEBUG("Connection handled");
		return p;
	}
};

int main()
{
	memset(buf, 'a', sizeof(buf));
	signal(SIGPIPE, SIG_IGN);

	if (!InitCsocket())
		return 2;

	CSListener L(PORT, HOST);
	L.SetSockName("Listener");
	L.SetIsSSL(true);

	CMySock *pListen = new CMySock();
	pListen->SetPemLocation(PEM);

	TSocketManager<CMySock> manager;
	if (!manager.Listen(L, pListen))
		return 1;

	CS_DEBUG("startup complete");

	while (true)
		manager.DynamicSelectLoop(100, 10000000);

	return 0;
}
